﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading;
using System.Threading.Tasks;

namespace Rendez_Vous_prolungato
{
    class Program
    {
        const int NumValori = 10;
        static int buffer;
        // Il buffer è inizialmente vuoto
        static SemaphoreSlim bufferVuoto = new SemaphoreSlim(1);  
        static SemaphoreSlim bufferPieno = new SemaphoreSlim(0);
        static void Main(string[] args)
        {
            Parallel.Invoke(Metti, Togli);
        }

        static void Metti()
        {
            Random r = new Random(2018);
            for(int i = 0; i < NumValori; i++)
            {
                int valorePari;
                do
                {
                    valorePari = r.Next(100);
                }
                while (valorePari % 2 != 0);    // Ripeti se il numero non è pari

                bufferVuoto.Wait();     // Attende che il buffer si svuoti
                Thread.Sleep(100);
                buffer = valorePari;
                Console.WriteLine("La procedura Metti ha inserito nel buffer il numero {0}", 
                    buffer);
                bufferPieno.Release();  // Segnala che il buffer è di nuovo pieno
            }


        }
        static void Togli()
        {
            for (int i = 0; i < NumValori; i++)
            {
                bufferPieno.Wait();     // Attende che il buffer si riempia
                Thread.Sleep(50);
                Console.WriteLine("La procedura Togli ha estratto dal buffer il numero {0}", 
                    buffer);
                bufferVuoto.Release();  // Segnala che ora il buffer è vuoto
            }

        }
    }
}
